import { checkPermissionsAndSetting } from './permission.js';

let platform = 'mp';
// #ifdef APP-PLUS  
platform = uni.getSystemInfoSync().platform;
// #endif
// #ifdef H5  
platform = 'h5';
// #endif


export function exit() {
  if (platform == 'android') {
    // 安卓退出app
    plus.runtime.quit();
  } else if (platform == 'ios') {
    // 判断为ios的手机，退出App   
    plus.ios.import("UIApplication").sharedApplication().performSelector("exit");
  }
}


export function openUrlNoNull(url) {
	if(url==null||url==''){
		console.log("空地址")
		return;
	}
	
  openUrl(url)
}

export function openUrl(url) {
	// if(url==null||url==''){
	// 	console.log("空地址")
	// 	return;
	// }
	
  // #ifdef APP-PLUS
  //这里默认使用外部浏览器打开而不是内部web-view组件打开
  console.log(url)
  
  plus.runtime.openURL(url)
  // #endif
  // #ifdef H5
  window.location.href=url
  // window.open(url)
  // #endif
}

export function saveCanvasImage(canvasId) {
  // #ifdef APP-PLUS
  let hasPermission = checkPermissionsAndSetting(['photoLibrary'], '检测到您未授权相机或者相册权限');

  if (hasPermission) {
    // #endif
    uni.canvasToTempFilePath({
      canvasId,
      success: (res) => {
        console.log(res.tempFilePath)
        uni.saveImageToPhotosAlbum({
          filePath: res.tempFilePath,
          success: (res2) => {
            uni.showToast({
              title: '保存成功',
              icon: "success"
            })
          },
          fail: (err) => {
            uni.showToast({
              title: '保存失败',
              icon: "error"
            })
          }
        })
      }
    })
    // #ifdef APP-PLUS
  }

  // #endif
}
